int  enhance_stanga = 0;
int  enhance_dreapta = 0;


// motor dreapta
int enA = 6;
int in1 = 7;
int in2 = 8;

// motor stanga
int enB = 11;
int in4 = 10;
int in3 = 9;

//senzor de distanta
int trigPin = 12;
int echoPin = 13;
long duration;
int distance;

// senzori infrarosii
int right = 2;
int left = 3;

//buzzer
int buzzer = 4;

ISR(INT0_vect)
{
  enhance_stanga = 1;
}

ISR(INT1_vect)
{
  enhance_dreapta = 1;
}


void setupINT0()
{
  // configurare intrerupere INT0 pe rising edge
  EICRA |= (1 << ISC01);
  EICRA |= (1 << ISC00);
  // activare intrerupere externa INT0
  EIMSK |= (1 << INT0);
}

void setupINT1()
{
  // configurare intrerupere INT1 pe rising edge
  EICRA |= (1 << ISC11);
  EICRA |= (1 << ISC11);
  // activare intrerupere externa INT1
  EIMSK |= (1 << INT1);
}
void setup() {
  // definire pini
  pinMode(enA , OUTPUT);
  pinMode(in1 , OUTPUT);
  pinMode(in2 , OUTPUT);

  pinMode(enB , OUTPUT);
  pinMode(in3 , OUTPUT);
  pinMode(in4 , OUTPUT);

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);

  pinMode(right , INPUT);
  pinMode(left, INPUT);
  Serial.begin(9600);

  // definire intreruperi INT0 si INT1
  setupINT0();
  setupINT1();


  // setup directie roti motor dreapta
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);

  // setup directie roti motor stanga
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);



}
int ia_distanta()
{
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2;
  return distance;

}

void make_dreapta_spate() {

  // dreapta spate
  digitalWrite( in1, HIGH);
  digitalWrite( in2, LOW);
}

void make_dreapta_fata() {
  digitalWrite( in1, LOW);
  digitalWrite( in2, HIGH);

}

void make_stanga_spate() {
  digitalWrite( in3, LOW);
  digitalWrite( in4, HIGH);
}

void make_stanga_fata() {
  digitalWrite( in3, HIGH);
  digitalWrite( in4, LOW);
}
void power_stanga(){
  
  analogWrite(enA , 0);
  analogWrite(enB, 130);
  

}

void power_dreapta(){
  analogWrite(enA , 130);
  analogWrite(enB, 0);
  
}

void normal()
{
  // asa merge drept rotile in fata
  analogWrite(enA , 150);
  analogWrite(enB, 150);
}

void stop() {
  analogWrite(enA, 0);
  analogWrite(enB, 0);
}
void loop() {
  // put your main code here, to run repeatedly:
  //normal();
  if ( ia_distanta() < 15)
  {
    stop();
  }
  else
  {
    if (enhance_dreapta)
    {
      enhance_dreapta = 0;
      while( digitalRead(left) == 0)
      {
        power_stanga();
      }
    }
    else if ( enhance_stanga)
    {
      enhance_stanga = 0;
      while(digitalRead(right) == 0)
      {
        
        power_dreapta();
      }     
    } 
    else
    {
      normal();
    }  

  }
  


}



// alternativa

  // if( digitalRead(right) == 0 && digitalRead(left)== 1)
  // {
  //   Serial.println("Virez dreapta");
    // while(digitalRead(right) == 0)
    //   power_dreapta();
    
  // }
  // else if ( digitalRead(right) == 1 && digitalRead(left)== 0)
  // {
  //   Serial.println("Virez stanga");
  //   while( digitalRead(left) == 0)
  //     power_stanga();
    
  // }
  // else if ( digitalRead(right) == 0 && digitalRead(left)== 0)
  // {
  //   Serial.println("Normal");
  //   normal();
  // }
